package org.jeecg.modules.itdmFirstPage.controller;


import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.itdmFirstPage.dto.ItdmTaskQueryDTO;
import org.jeecg.modules.itdmFirstPage.service.IItdmTaskService;
import org.jeecg.modules.itdmFirstPage.vo.ItdmFirstPageVO;
import org.jeecg.modules.system.service.ISysRoleService;
import org.jeecg.modules.system.service.ISysUserRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@Api(tags="...首页")
@RestController
@RequestMapping("/itdmFirstPage")
@Slf4j
public class itdmFirstPageController {

    @Autowired
    private IItdmTaskService taskService;
    @Autowired
    private ISysUserRoleService sysUserRoleService;
    @Autowired
    private ISysRoleService roleService;

    @ApiOperation(value="任务各种数量", notes="所有任务，待办，进行中，完成")
    @GetMapping(value = "/getFrstPageTaskNum")
    public ItdmFirstPageVO getFrstPageTaskNum(){
        LoginUser loginUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        String realName = loginUser.getRealname(); // 登录人姓名
        String username = loginUser.getUsername(); // 登录账号
        System.out.println("realName:"+ realName+ "  username:"+ username);

        ItdmTaskQueryDTO dto = new ItdmTaskQueryDTO();
        if(!username.equals("admin")){
            dto.setTaskUser(realName);
        }

        Long totalNum = taskService.queryTaskTotal(dto);

        dto.setTaskStatus(0);
        Long daibanNum = taskService.queryTaskTotal(dto);

        dto.setTaskStatus(1);
        Long jinxingNum = taskService.queryTaskTotal(dto);

        dto.setTaskStatus(2);
        Long wanchengNum =taskService.queryTaskTotal(dto);

        ItdmFirstPageVO firstPageVO = new ItdmFirstPageVO();
        firstPageVO.setDaibanNum(daibanNum);
        firstPageVO.setJinxingNum(jinxingNum);
        firstPageVO.setWanchengNum(wanchengNum);
        firstPageVO.setTotalNum(totalNum);

        return firstPageVO;
    }


}
