package org.jeecg.modules.weituo.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.jeecg.modules.weituo.entity.ItdmWeituoInfo;
import org.jeecg.modules.weituo.entity.ItdmWeituoJieXaingVo;

import java.util.List;

/**
 * @Description: 委托信息
 * @Author: jeecg-boot
 * @Date: 2023-05-17
 * @Version: V1.0
 */
public interface ItdmWeituoInfoMapper extends BaseMapper<ItdmWeituoInfo> {

    /**
     * 根据工单id修改委托进度
     */
    @Select("UPDATE itdm_weituo_info w " +
            "    INNER JOIN itdm_test_plan p ON w.id = p.weituo_id " +
            "    INNER JOIN itdm_gongdan_master m ON p.id = m.jihua_shiyan_id  " +
            "SET w.weituo_step = #{weituoStep} " +
            "WHERE m.id =  #{woId}")
    public void updateWeituoStepByWoId(@Param("woId") String woId,@Param("weituoStep") String weituoStep);

    /**
     * 根据工单detail id修改委托进度
     */
    @Select("UPDATE itdm_weituo_info w " +
            "    INNER JOIN itdm_test_plan p ON w.id = p.weituo_id " +
            "    INNER JOIN itdm_gongdan_master m ON p.id = m.jihua_shiyan_id  " +
            "    INNER JOIN itdm_gongdan_detail d ON m.id = d.wo_id " +
            "SET w.weituo_step = #{weituoStep} " +
            "WHERE d.id =  #{detailId}")
    public void updateWeituoStepByDetailId(@Param("detailId") String detailId,@Param("weituoStep") String weituoStep);

    /**
     * 根据委托id修改委托进度
     */
    @Select("update itdm_weituo_info set weituo_step =#{weituoStep} where id = #{weituoId}")
    public void updateWeituoStepByWeituoId(@Param("weituoId") String weituoId,@Param("weituoStep") String weituoStep);

    /**
     * 根据委托编号修改委托进度
     */
    @Select("update itdm_weituo_info set weituo_step =#{weituoStep} where weituo_no = #{weituoNo}")
    public void updateWeituoStepByWeituoNo(@Param("weituoNo") String weituoNo,@Param("weituoStep") String weituoStep);

    /**
     * 根据委托编号修改委托状态（0未完结1已完结）
     */
    @Select("update itdm_weituo_info set complete_status =1 where weituo_no = #{weituoNo}")
    String updateCompleteStatusByWeituoNo(@Param("weituoNo") String weituoNo);

    /**
     * 根据委托单位查询委托信息列表
     */
    @Select("select * from itdm_weituo_info where weituo_client like  '%${weituoClient}%' and shenhe_status =1 ")
    public List<ItdmWeituoInfo> selectWTListByClient(@Param("weituoClient") String weituoClient);


    @Select("select * from itdm_weituo_info where  shenhe_status =1 ")
    public List<ItdmWeituoInfo> selectShenheOk();




    /**
     * 查询委托单位名称（不重复）
     */
    @Select("select distinct weituo_client from itdm_weituo_info")
    public List<String> selectDistinctClientList();

    /**
     * 根据委托编号查询委托id
     */
    @Select("select id from itdm_weituo_info where weituo_no = #{weituoNo}")
    String selectByWeituoNo(@Param("weituoNo") String weituoNo);

    /**
    *   author: dzc
    *   version: 1.0
    *   des: 查询委托的试验计划排期信息
    *   date: 2023/11/10
    */
    public List<ItdmWeituoJieXaingVo> getWeituoList(IPage page,@Param("itdmWeituoInfo")ItdmWeituoInfo itdmWeituoInfo);
}
